Xapian: API Documentation: xapian-core: Xapian::ValuePostingSource Class Reference

# Xapian::ValuePostingSource Class Reference

A posting source which generates weights from a value slot. More...

Inheritance diagram for Xapian::ValuePostingSource:

[legend]

List of all members.

## Public Member Functions
| ValuePostingSource (Xapian::valueno slot_)
| Construct a ValuePostingSource.
Xapian::doccount | get_termfreq_min () const
| A lower bound on the number of documents this object can return.
Xapian::doccount | get_termfreq_est () const
| An estimate of the number of documents this object can return.
Xapian::doccount | get_termfreq_max () const
| An upper bound on the number of documents this object can return.
void | next (Xapian::weight min_wt)
| Advance the current position to the next matching document.
void | skip_to (Xapian::docid min_docid, Xapian::weight min_wt)
| Skip forward to the specified docid.
bool | check (Xapian::docid min_docid, Xapian::weight min_wt)
| Check if the specified docid occurs.
bool | at_end () const
| Return true if the current position is past the last entry in this list.
Xapian::docid | get_docid () const
| Return the current docid.
void | init (const Database &db_)
| Set this PostingSource to the start of the list of postings.
## Protected Attributes
Xapian::Database | db
| The database we're reading values from.
Xapian::valueno | slot
| The slot we're reading values from.
Xapian::ValueIterator | value_it
| Value stream iterator.
bool | started
| Flag indicating if we've started (true if we have).
Xapian::doccount | termfreq_min
| A lower bound on the term frequency.
Xapian::doccount | termfreq_est
| An estimate of the term frequency.
Xapian::doccount | termfreq_max
| An upper bound on the term frequency.

## Detailed Description

A posting source which generates weights from a value slot.

This is a base class for classes which generate weights using values stored in the specified slot. For example, ValueWeightPostingSource uses sortable_unserialise to convert values directly to weights.

The upper bound on the weight returned is set to DBL_MAX. Subclasses should call set_maxweight() in their init() methods after calling ValuePostingSource::init() if they know a tighter bound on the weight.

## Constructor & Destructor Documentation

Xapian::ValuePostingSource::ValuePostingSource | ( | Xapian::valueno | slot_ | ) |

Construct a ValuePostingSource.

Parameters:

  | slot_ | The value slot to read values from.

## Member Function Documentation

bool Xapian::ValuePostingSource::at_end | ( |  | ) | const`[virtual]`

Return true if the current position is past the last entry in this list.

At least one of next(), skip_to() or check() will be called before this method is first called.

Implements Xapian::PostingSource.

bool Xapian::ValuePostingSource::check | ( | Xapian::docid | did,
|  | Xapian::weight | min_wt |
| ) |  |  | `[virtual]`

Check if the specified docid occurs.

The caller is required to ensure that the specified document id did actually exists in the database. If it does, it must move to that document id, and return true. If it does not, it may either:

- return true, having moved to a definite position (including "at_end"), which must be the same position as skip_to() would have moved to.

or

- return false, having moved to an "indeterminate" position, such that a subsequent call to next() or skip_to() will move to the next matching position after did.

Generally, this method should act like skip_to() and return true if that can be done at little extra cost.

Otherwise it should simply check if a particular docid is present, returning true if it is, and false if it isn't.

The default implementation calls skip_to() and always returns true.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Reimplemented from Xapian::PostingSource.

Reimplemented in Xapian::DecreasingValueWeightPostingSource.

Xapian::docid Xapian::ValuePostingSource::get_docid | ( |  | ) | const`[virtual]`

Return the current docid.

This method may assume that it will only be called when there is a "current document". See get_weight() for details.

Note: in the case of a multi-database search, the returned docid should be in the single subdatabase relevant to this posting source. See the init() method for details.

Implements Xapian::PostingSource.

Xapian::doccount Xapian::ValuePostingSource::get_termfreq_est | ( |  | ) | const`[virtual]`

An estimate of the number of documents this object can return.

It must always be true that:

get_termfreq_min() <= get_termfreq_est() <= get_termfreq_max()

Xapian will always call init() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

Xapian::doccount Xapian::ValuePostingSource::get_termfreq_max | ( |  | ) | const`[virtual]`

An upper bound on the number of documents this object can return.

Xapian will always call init() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

Xapian::doccount Xapian::ValuePostingSource::get_termfreq_min | ( |  | ) | const`[virtual]`

A lower bound on the number of documents this object can return.

Xapian will always call init() on a PostingSource before calling this for the first time.

Implements Xapian::PostingSource.

void Xapian::ValuePostingSource::init | ( | const Database & | db | ) | `[virtual]`

Set this PostingSource to the start of the list of postings.

This is called automatically by the matcher prior to each query being processed.

If a PostingSource is used for multiple searches, init() will therefore be called multiple times, and must handle this by using the database passed in the most recent call.

Parameters:

  | db | The database which the PostingSource should iterate through.

Note: the database supplied to this method must not be modified: in particular, the reopen() method should not be called on it.

Note: in the case of a multi-database search, a separate PostingSource will be used for each database (the separate PostingSources will be obtained using clone()), and each PostingSource will be passed one of the sub-databases as the db parameter here. The db parameter will therefore always refer to a single database. All docids passed to, or returned from, the PostingSource refer to docids in that single database, rather than in the multi-database.

Implements Xapian::PostingSource.

Reimplemented in Xapian::ValueWeightPostingSource, Xapian::DecreasingValueWeightPostingSource, and Xapian::ValueMapPostingSource.

void Xapian::ValuePostingSource::next | ( | Xapian::weight | min_wt | ) | `[virtual]`

Advance the current position to the next matching document.

The PostingSource starts before the first entry in the list, so next() must be called before any methods which need the context of the current position.

Xapian will always call init() on a PostingSource before calling this for the first time.

Parameters:

  | min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Implements Xapian::PostingSource.

Reimplemented in Xapian::DecreasingValueWeightPostingSource.

void Xapian::ValuePostingSource::skip_to | ( | Xapian::docid | did,
|  | Xapian::weight | min_wt |
| ) |  |  | `[virtual]`

Skip forward to the specified docid.

If the specified docid isn't in the list, position ourselves on the first document after it (or at_end() if no greater docids are present).

If the current position is already the specified docid, this method will leave the position unmodified.

If the specified docid is earlier than the current position, the behaviour is unspecified. A sensible behaviour would be to leave the current position unmodified, but it is also reasonable to move to the specified docid.

The default implementation calls next() repeatedly, which works but skip_to() can often be implemented much more efficiently.

Xapian will always call init() on a PostingSource before calling this for the first time.

Note: in the case of a multi-database search, the docid specified is the docid in the single subdatabase relevant to this posting source. See the init() method for details.

Parameters:

  | min_wt | The minimum weight contribution that is needed (this is just a hint which subclasses may ignore).

Reimplemented from Xapian::PostingSource.

Reimplemented in Xapian::DecreasingValueWeightPostingSource.

## Member Data Documentation

Xapian::doccount Xapian::ValuePostingSource::termfreq_est`[protected]`

An estimate of the term frequency.

Subclasses should set this if they are overriding the next(), skip_to() or check() methods.

Xapian::doccount Xapian::ValuePostingSource::termfreq_max`[protected]`

An upper bound on the term frequency.

Subclasses should set this if they are overriding the next(), skip_to() or check() methods.

Xapian::doccount Xapian::ValuePostingSource::termfreq_min`[protected]`

A lower bound on the term frequency.

Subclasses should set this if they are overriding the next(), skip_to() or check() methods to return fewer documents.

The documentation for this class was generated from the following file:

- xapian/postingsource.h